"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/asyncToGenerator"));

var _core = _interopRequireDefault(require("@arice/core"));

var _xajs = require("xajs");

var _constants = require("./constants");

var bootstrap = function bootstrap(_ref) {
  var _ref$framework = _ref.framework,
      framework = _ref$framework === void 0 ? {} : _ref$framework,
      _ref$apps = _ref.apps,
      apps = _ref$apps === void 0 ? {} : _ref$apps,
      _ref$viewEngine = _ref.viewEngine,
      viewEngine = _ref$viewEngine === void 0 ? {} : _ref$viewEngine,
      _ref$plugins = _ref.plugins,
      plugins = _ref$plugins === void 0 ? [] : _ref$plugins,
      _ref$beforeBootstrap = _ref.beforeBootstrap,
      beforeBootstrap = _ref$beforeBootstrap === void 0 ? _constants.NOOP : _ref$beforeBootstrap,
      _ref$afterBootstrap = _ref.afterBootstrap,
      afterBootstrap = _ref$afterBootstrap === void 0 ? _constants.NOOP : _ref$afterBootstrap;
  return (
    /*#__PURE__*/
    function () {
      var _ref2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(appName) {
        var rf, bb, ab, k, ve, currentApp, bundlePromise, _currentApp$options, options, _currentApp$sideEffec, sideEffects, _currentApp$beforeBoo, _beforeBootstrap, _currentApp$afterBoot, _afterBootstrap, getBundle, app, _options$mountNode, mountNode, _options$props, props;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                rf = new _core["default"].Framework(framework);
                bb = beforeBootstrap, ab = afterBootstrap;
                _context.t0 = _regenerator["default"].keys(viewEngine);

              case 3:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 11;
                  break;
                }

                k = _context.t1.value;
                ve = viewEngine[k];

                if (ve.isRiceView) {
                  _context.next = 8;
                  break;
                }

                throw new Error("viewEngine: ".concat(k, " is not a valid rice view engine."));

              case 8:
                rf.defineView(k, ve);
                _context.next = 3;
                break;

              case 11:
                if (!(appName in apps)) {
                  _context.next = 32;
                  break;
                }

                currentApp = apps[appName];
                bundlePromise = currentApp.bundle, _currentApp$options = currentApp.options, options = _currentApp$options === void 0 ? _constants.DEFAULT_APP_OPTIONS : _currentApp$options, _currentApp$sideEffec = currentApp.sideEffects, sideEffects = _currentApp$sideEffec === void 0 ? _constants.NOOP : _currentApp$sideEffec, _currentApp$beforeBoo = currentApp.beforeBootstrap, _beforeBootstrap = _currentApp$beforeBoo === void 0 ? bb : _currentApp$beforeBoo, _currentApp$afterBoot = currentApp.afterBootstrap, _afterBootstrap = _currentApp$afterBoot === void 0 ? ab : _currentApp$afterBoot;

                getBundle = function getBundle() {
                  return null;
                };

                if (_xajs.internal.is.isFunction(bundlePromise)) {
                  getBundle = function getBundle() {
                    return bundlePromise().then(function (mod) {
                      return mod["default"];
                    });
                  };
                }

                _context.next = 18;
                return getBundle();

              case 18:
                app = _context.sent;

                if (app) {
                  _context.next = 21;
                  break;
                }

                throw new Error("Bundle of [".concat(appName, "] load failed, please check."));

              case 21:
                _context.next = 23;
                return _beforeBootstrap(rf, currentApp);

              case 23:
                _options$mountNode = options.mountNode, mountNode = _options$mountNode === void 0 ? null : _options$mountNode, _options$props = options.props, props = _options$props === void 0 ? {} : _options$props; // setup sideEffects

                _context.next = 26;
                return sideEffects(rf.$effectCenter.$effect);

              case 26:
                _context.next = 28;
                return rf.loadApp(app, mountNode, props, plugins);

              case 28:
                _context.next = 30;
                return _afterBootstrap(rf, currentApp);

              case 30:
                _context.next = 33;
                break;

              case 32:
                throw new Error("Can not find this app: ".concat(appName, "."));

              case 33:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }()
  );
};

var _default = bootstrap;
exports["default"] = _default;